// file: TextFileType.cs
// brief: File type class for plain text
// update: 2007-07-10
//=========================================================
using System;
using System.Windows.Forms;

namespace Sgry.AiBTools.AiBEdit
{
	/// <summary>
	/// v[eLXgt@Ct@C^Cv
	/// </summary>
	class TextFileType : IFileType
	{
		/// <summary>
		/// t@CޖBMRU ۑɎgB
		/// </summary>
		public string Name
		{
			get{ return "Text"; }
		}

		/// <summary>
		/// wpX̃t@C邩
		/// </summary>
		/// <param name="filePath">肷t@C̃pX</param>
		/// <returns>ꍇtrue</returns>
		public bool CanHandleFile( string filePath )
		{
			// łOK
			return true;
		}

		/// <summary>
		/// ̃AEgC\
		/// </summary>
		/// <returns>[UIV{CfbNX</returns>
		public int ShowOutline( Form owner, string docContent, int caretIndex )
		{
			DialogResult result;
			Outliner parser;

			using( OutlineDialog dialog = new OutlineDialog() )
			{
				// setup dialog
				dialog.Size = owner.Size;
				dialog.Location = owner.Location;
				
				// parse
				parser = new TextOutliner( dialog, docContent, caretIndex );
				parser.Parse();

				// show dialog
				result = dialog.ShowDialog( owner );
				if( result != DialogResult.OK )
				{
					return -1;
				}

				// return index of the selected symbol
				return dialog.SelectedSymbolIndex;
			}
		}

		/// <summary>
		/// ҏWΏۂRpC
		/// </summary>
		/// <returns>RpC</returns>
		public CompileResult Compile( Document doc )
		{
			return CompileResult.FailedToExecute;
		}

		/// <summary>
		/// rhR}hs
		/// </summary>
		/// <returns>RpC</returns>
		public CompileResult Build( Document doc )		
		{
			return CompileResult.FailedToExecute;
		}
	}
}
